<%@ Page Language="C#" %>
<html><head><script runat="server">

      void Button_Click(Object sender, EventArgs e) 
      {// *************
         if (Page.IsValid) {lblOutput.Text = "Rovnost!";}
         else              {lblOutput.Text = "Nerovnost!";}

      }
 
      void Operator_Index_Changed(Object sender, EventArgs e) 
      {//  **********************
       // Aktivuj validator pri zmene operatora
         Compare1.Operator = (ValidationCompareOperator)ListOperator.SelectedIndex;
         Compare1.Validate();

      }

      void Type_Index_Changed(Object sender, EventArgs e) 
      {//  **********************
       // Aktivuj validator pri zmene datoveho typu
         Compare1.Type = (ValidationDataType)ListType.SelectedIndex;
         Compare2.Type = (ValidationDataType)ListType.SelectedIndex;
         Compare1.Validate();

      }
   </script></head>


<body>
   <form runat="server">
      <h3>CompareValidator</h3>
      <table bgcolor="#eeeeee" cellpadding="10">
      <tr valign="top">
         <td>
            <h5>Retazec 1:</h5>
            <asp:TextBox id="TextBox1" runat="server"/><br>
            <asp:CompareValidator id="Compare1" 
                 ControlToValidate="TextBox1" 
                 ControlToCompare="TextBox2" 
                 Type="String"
                 EnableClientScript="false" 
                 Text="Failed Validation" 
                 runat="server"/>
         </td>
         <td>
            <h5>Porovnavaci operator:</h5>
            <asp:ListBox id="ListOperator" 
                 OnSelectedIndexChanged="Operator_Index_Changed" 
                 runat="server">
           <asp:ListItem Selected Value="Equal" >Equal</asp:ListItem>
           <asp:ListItem Value="NotEqual" >NotEqual</asp:ListItem>
           <asp:ListItem Value="GreaterThan" >GreaterThan</asp:ListItem>
           <asp:ListItem Value="GreaterThanEqual" >GreaterThanEqual </asp:ListItem>
           <asp:ListItem Value="LessThan" >LessThan</asp:ListItem>
           <asp:ListItem Value="LessThanEqual" >LessThanEqual </asp:ListItem>
           <asp:ListItem Value="DataTypeCheck" >DataTypeCheck</asp:ListItem>
           </asp:ListBox>
           </td>

           <td>
            <h5>Retazec 2:</h5>
            <asp:TextBox id="TextBox2" runat="server"/><br>
            <asp:CompareValidator id="Compare2" 
                 ControlToValidate="TextBox2"  
                 Operator="DataTypeCheck"
                 EnableClientScript="false"
                 Text="Invalid Data Type" 
                 runat="server"/>
            <br>
            <asp:Button id="Button1"
                 Text="Skontroluj"  
                 OnClick="Button_Click" 
                 runat="server"/>
          </td>
      </tr>
      <tr>
         <td colspan="3" align="center">
            <h5>Datovy typ:</h5>
            <asp:ListBox id="ListType" 
                 OnSelectedIndexChanged="Type_Index_Changed" runat="server">
               <asp:ListItem Selected Value="String" >String</asp:ListItem>
               <asp:ListItem Value="Integer" >Integer</asp:ListItem>
               <asp:ListItem Value="Double" >Double</asp:ListItem>
               <asp:ListItem Value="Date" >Date</asp:ListItem>
               </asp:ListBox>
            </td>
         </tr>
      </table>
      <br>
       
      <asp:Label id="lblOutput" 
           Font-Name="verdana" 
           Font-Size="10pt" 
           runat="server"/>
 
   </form>
</body></html>
